#ifndef GAME_H
#define GAME_H

#include "utils.h"
#include "Shader.h"
#include "Block.h"
#include "Chunk.h"
#include "utils.h"
#include "Camera.h"
#include "World.h"
#include "Player.h"
#include "Luminary.h"
#include "Sun.h"
#include "Moon.h"
#include "Sky.h"
#include "Texture.h"
#include "Shader.h"
#include "FrameBuffer.h"

constexpr float reflection_quality = 0.5f;	// Qualit des reflets (de 0  1)
constexpr float refraction_quality = 1.f;	// Qualit de la rfraction (de 0  1)

// Classe dfinissant le jeu

class Game
{
public:

	static World					world;			// Le monde
	static Sun						sun;			// Le soleil
	static Moon						moon;			// La lune
	static Sky						sky;			// Le ciel
	static std::stack<glm::mat4>	matrices;		// La pile de matrices
	static Player					player;			// Le joueur
	static Camera					fixed_cam;		// Camra fixe par le joueur
	static bool						fix_cam;		// La camra est fixe
	static bool						stop_moving;	// Arrte de bouger la camra
	static float					time;			// Temps coul

	static void						init();
	static void						checks_events(const SDL_Event& my_event);
	static void						update(glm::ivec2& mouse_pos);
	static void						draw();
};

#endif